Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# ModifierButtons Class Reference

This class monitors the state of a number of individual buttons and tracks whether each button is known to be down or up. More...

List of all members.

## Public Member Functions
| ModifierButtons ()
| ModifierButtons (ModifierButtons const copy)
bool | addButton (ButtonHandle button)
| Adds the indicated button to the set of buttons that will be monitored for upness and downness.
| allButtonsUp ()
| Marks all monitored buttons as being in the "up" state.
bool | buttonDown (ButtonHandle button)
| Records that a particular button has been pressed.
bool | buttonUp (ButtonHandle button)
| Records that a particular button has been released.
ButtonHandle | getButton (int index)
| Returns the nth button that the ModifierButtons object is monitoring (the nth button passed to add_button()).
list | getButtons ()
int | getNumButtons ()
| Returns the number of buttons that the ModifierButtons object is monitoring (e.g.
string | getPrefix ()
| Returns a string which can be used to prefix any button name or event name with the unique set of modifier buttons currently being held.
bool | hasButton (ButtonHandle button)
| Returns true if the indicated button is in the set of buttons being monitored, false otherwise.
bool | isAnyDown ()
| Returns true if any of the tracked button are known to be down, or false if all of them are up.
bool | isDown (ButtonHandle button)
| Returns true if the indicated button is known to be down, or false if it is known to be up or if it is not in the set of buttons being tracked.
bool | isDown (int index)
| Returns true if the indicated button is known to be down, or false if it is known to be up.
bool | matches (ModifierButtons const other)
| Returns true if the set of buttons indicated as down by this ModifierButtons object is the same set of buttons indicated as down by the other ModifierButtons object.
bool | operator!= (ModifierButtons const other)
ModifierButtons | operator& (ModifierButtons const other)
| Returns a new ModifierButtons object for which is_down() will be true only if it is true on both source objects.
ModifierButtons | operator&= (ModifierButtons const other)
| Sets is_down() true for any button that is already true for this object and the other object.
bool | operator< (ModifierButtons const other)
ModifierButtons | operator= (ModifierButtons const copy)
bool | operator== (ModifierButtons const other)
| The equality operator is an exact comparision: the two ModifierButtons are equal if they share the same button list--indeed, the same pointer--and they all the buttons have the same state.
ModifierButtons | operator| (ModifierButtons const other)
| Returns a new ModifierButtons object for which is_down() will be true if it is true on either of the source objects.
ModifierButtons | operator|= (ModifierButtons const other)
| Sets is_down() true for any button that is already true for this object and the other object.
| output (ostream out)
| Writes a one-line summary of the buttons known to be down.
bool | removeButton (ButtonHandle button)
| Removes the indicated button from the set of buttons being monitored.
| setButtonList (ModifierButtons const other)
| Sets the list of buttons to watch to be the same as that of the other ModifierButtons object.
| write (ostream out)
| Writes a multi-line summary including all of the buttons being monitored and which ones are known to be down.

## Detailed Description

This class monitors the state of a number of individual buttons and tracks whether each button is known to be down or up.

## Constructor & Destructor Documentation

ModifierButtons | ( |  | ) |

ModifierButtons | ( | ModifierButtons const | copy | ) |

## Member Function Documentation

bool addButton | ( | ButtonHandle | button | ) |

Adds the indicated button to the set of buttons that will be monitored for upness and downness.

Returns true if the button was added, false if it was already being monitored or if too many buttons are currently being monitored.

allButtonsUp | ( |  | ) |

Marks all monitored buttons as being in the "up" state.

bool buttonDown | ( | ButtonHandle | button | ) |

Records that a particular button has been pressed.

If the given button is one of the buttons that is currently being monitored, this will update the internal state appropriately; otherwise, it will do nothing. Returns true if the button is one that was monitored, or false otherwise.

bool buttonUp | ( | ButtonHandle | button | ) |

Records that a particular button has been released.

If the given button is one of the buttons that is currently being monitored, this will update the internal state appropriately; otherwise, it will do nothing. Returns true if the button is one that was monitored, or false otherwise.

ButtonHandle getButton | ( | int | index | ) |

Returns the nth button that the ModifierButtons object is monitoring (the nth button passed to add_button()).

This must be in the range 0 <= index < get_num_buttons().

list getButtons | ( |  | ) |

int getNumButtons | ( |  | ) |

Returns the number of buttons that the ModifierButtons object is monitoring (e.g.

the number of buttons passed to add_button()).

string getPrefix | ( |  | ) |

Returns a string which can be used to prefix any button name or event name with the unique set of modifier buttons currently being held.

bool hasButton | ( | ButtonHandle | button | ) |

Returns true if the indicated button is in the set of buttons being monitored, false otherwise.

bool isAnyDown | ( |  | ) |

Returns true if any of the tracked button are known to be down, or false if all of them are up.

bool isDown | ( | ButtonHandle | button | ) |

Returns true if the indicated button is known to be down, or false if it is known to be up or if it is not in the set of buttons being tracked.

bool isDown | ( | int | index | ) |

Returns true if the indicated button is known to be down, or false if it is known to be up.

bool matches | ( | ModifierButtons const | other | ) |

Returns true if the set of buttons indicated as down by this ModifierButtons object is the same set of buttons indicated as down by the other ModifierButtons object.

The buttons indicated as up are not relevant.

bool operator!= | ( | ModifierButtons const | other | ) |

ModifierButtons operator& | ( | ModifierButtons const | other | ) |

Returns a new ModifierButtons object for which is_down() will be true only if it is true on both source objects.

The set of buttons reported by has_button() is not completely defined if both source objects have a different set.

ModifierButtons operator&= | ( | ModifierButtons const | other | ) |

Sets is_down() true for any button that is already true for this object and the other object.

bool operator< | ( | ModifierButtons const | other | ) |

ModifierButtons operator= | ( | ModifierButtons const | copy | ) |

bool operator== | ( | ModifierButtons const | other | ) |

The equality operator is an exact comparision: the two ModifierButtons are equal if they share the same button list--indeed, the same pointer--and they all the buttons have the same state.

Use matches() if a less exact equality test is needed.

ModifierButtons operator| | ( | ModifierButtons const | other | ) |

Returns a new ModifierButtons object for which is_down() will be true if it is true on either of the source objects.

The set of buttons reported by has_button() is not completely defined if both source objects have a different set.

ModifierButtons operator|= | ( | ModifierButtons const | other | ) |

Sets is_down() true for any button that is already true for this object and the other object.

Adds whatever buttons are necessary to the list to make this so

output | ( | ostream | out | ) |

Writes a one-line summary of the buttons known to be down.

bool removeButton | ( | ButtonHandle | button | ) |

Removes the indicated button from the set of buttons being monitored.

Returns true if the button was removed, false if it was not being monitored in the first place.

Unlike the other methods, you cannot remove a button by removing its alias; you have to remove exactly the button itself.

setButtonList | ( | ModifierButtons const | other | ) |

Sets the list of buttons to watch to be the same as that of the other ModifierButtons object.

This makes the lists pointer equivalent (until one or the other is later modified).

This will preserve the state of any button that was on the original list and is also on the new lists. Any other buttons will get reset to the default state of "up".

write | ( | ostream | out | ) |

Writes a multi-line summary including all of the buttons being monitored and which ones are known to be down.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties